/**
 * This class represents a flatmenu.
 * @author eCube GmbH, Christian Heilmann
 * @version 0.1
 *
 * Dont forget to preload the images for the menu!
 *
 * import dynapi.api.dynlayer;
 * import dynapi.api.events;
 * import dynapi.gui.dynimage;
 */
function FlatMenu(x, y, itemWidth, itemHeight, imgsAry, styleClassNormal, styleClassSelected){
	this.x = x;
	this.y = y;
	this.ItemWidth = itemWidth;
	this.ItemHeight = itemHeight;
	this.imgsAry = imgsAry;
	this.flatMenuItemAry = new Array();
	this.currentIndex = -1;
	this.currentChildIndex = -1;
	this.styleClassSelected = styleClassSelected;
	this.styleClassNormal = styleClassNormal;
	this.firstExpand = true;
}
FlatMenu.preloadFlatMenuImgs = function(imgTheme, w, h){
    var imgs = new Array();
    var i = 0;
    imgs[i++] = DynImage.getImage(imgTheme+FlatMenu.ImageNormalStrg,w,h);
    imgs[i++] = DynImage.getImage(imgTheme+FlatMenu.ImageSelectedStrg,w,h);
    imgs[i++] = DynImage.getImage(imgTheme+FlatMenu.ImageTransparentStrg,w,h);
    FlatMenu.ItemHeight = h;
    FlatMenu.ItemWidth = w;
    return imgs;
}
FlatMenu.ImageNormalStrg = 'images/flatmenu-normal.gif';
FlatMenu.ImageSelectedStrg = 'images/flatmenu-selected.gif';
FlatMenu.ImageTransparentStrg = 'images/flatmenu-transparent.gif';
FlatMenu.ItemHSpace = 0;
FlatMenu.ItemZSpace = 5;
//public
FlatMenu.prototype.add = function(flatMenuItem){
	var i = this.flatMenuItemAry.length;
	flatMenuItem.setStyle(this.imgsAry, this.styleClassNormal, this.styleClassSelected);
	flatMenuItem.setFlatMenu(this,i);
	//maggie: take its own textHeight as set up in navdef
	flatMenuItem.init(this.ItemWidth,flatMenuItem.textHeight);
	//flatMenuItem.init(this.ItemWidth,this.ItemHeight);
	if(flatMenuItem.hasChilds()){
		var c = flatMenuItem.getChilds();
		for(var z = 0; z < c.length; z++){
			c[z].setStyle(this.imgsAry, this.styleClassNormal, this.styleClassSelected);
			c[z].setFlatMenu(this, -1);
			c[z].init(this.ItemWidth,this.ItemHeight);
		}
	}
	this.flatMenuItemAry[i] = flatMenuItem;
}
//public
FlatMenu.prototype.expand = function(flatMenuIndex, selectedIndex){
	working = true;
	if(this.currentIndex > -1){
		if(this.flatMenuItemAry[this.currentIndex].hasChilds()){
			var childs = this.flatMenuItemAry[this.currentIndex].getChilds();
			for(var i = 0; i < childs.length; i++){
				if(i == this.currentChildIndex){
					childs[i].setSelected(false);
				}
				childs[i].setVisible(false);
			}
		}
		this.flatMenuItemAry[this.currentIndex].setSelected(false);
	}
	var newYFactor = 0;
	//maggie
	var ypos = 30;
	for(var i = 0; i < this.flatMenuItemAry.length; i++){
		var item = this.flatMenuItemAry[i];
		item.moveTo(this.x, (ypos)+this.y);
		ypos += item.textHeight + FlatMenu.ItemHSpace;
		//newYFactor++;
		//item.moveTo(this.x, (newYFactor*(this.ItemHeight+FlatMenu.ItemHSpace))+this.y);
		item.setVisible(true);
		if(i == flatMenuIndex){
			if(selectedIndex == -1){
				if(this.firstExpand){
					item.setPermanent(true);
					this.firstExpand = false;
				}
				item.setSelected(true);
			}
			if(item.hasChilds() ){
				var itemChilds = item.getChilds();
				for(var z = 0; z < itemChilds.length; z++){
					if(z == selectedIndex){
						if(this.firstExpand){
							itemChilds[z].setPermanent(true);
							this.fristExpand = false;
						}
						itemChilds[z].setSelected(true);
					}
					newYFactor++;
					itemChilds[z].moveTo(this.x+FlatMenu.ItemZSpace, (newYFactor*(this.ItemHeight+FlatMenu.ItemHSpace))+this.y);
					itemChilds[z].setVisible(true);
				}
			}
		}
	}
	this.currentIndex = flatMenuIndex;
	this.currentChildIndex =  selectedIndex;
	this.firstExpand = false;
	working = false;
}

//public
function FlatMenuItem (text, url, height){
	this.text = text;
	this.url = url;
	this.textHeight = ( height || FlatMenu.ItemHeight);
	this.childrenAry = new Array();
	this.childs = false;
	this.imgLyr = null;
	this.txtLyr = null;
	this.transLyr = null;
	this.flatMenu = null;
	this.flatMenuIndex = null;
	this.imgAry = null;
	this.styleClassNormal = null;
	this.styleClassSelected = null;
	this.permanent = false;
	return this;
}
//public
FlatMenuItem.prototype.add = function(flatMenuItem){
	var i = this.childrenAry.length;
	this.childrenAry[i] = flatMenuItem;
	this.childs = true;
}
//public
FlatMenuItem.prototype.hasChilds = function(){
	return this.childs;
}
//public
FlatMenuItem.prototype.getChilds = function(){
	return this.childrenAry;
}
//public
FlatMenuItem.prototype.setStyle = function(imgAry, styleClassNormal, styleClassSelected){
	this.imgAry = imgAry;
	this.styleClassNormal = styleClassNormal;
	this.styleClassSelected = styleClassSelected;
}
//public
FlatMenuItem.prototype.setFlatMenu = function(flatMenu, flatMenuIndex){
	this.flatMenu = flatMenu;
	this.flatMenuIndex = flatMenuIndex;
}
//public
FlatMenuItem.prototype.init = function(w, h){
	this.imgLyr = new DynImage(this.imgAry[0]);
	//maggie:take the original width of the images
	this.imgLyr.setSize(w, FlatMenu.ItemHeight);
	this.imgLyr.setVisible(false);
	this.txtLyr = new DynLayer();
	this.txtLyr.setHTML("<span class=\""+this.styleClassNormal+"\">"+this.text+"</span>");
	//maggie: but text area may be higher
	this.txtLyr.setSize(w,h);
	this.txtLyr.setVisible(false);
	this.transLyr = new DynImage(this.imgAry[2]);
	//maggie
	this.transLyr.setSize(w,h);
	this.transLyr.setVisible(false);
	this.transLyr.menuItem = this;
	var listener = new EventListener(this.transLyr);
	listener.onmousedown = function(e){
		var o = e.getTarget();
		if(!working){
			if(o.menuItem.url != ''){
				o.menuItem.showUrl();
			}else{
				if(o.menuItem.hasChilds()){
					o.menuItem.flatMenu.expand(o.menuItem.flatMenuIndex, -1);
				}
			}
		}

	}
	listener.onmouseover = function(e){
		var o = e.getTarget();
		if(!working){
			o.menuItem.setSelected(true);
		}
		e.setBubble(false);
	}
	listener.onmouseout = function(e){
		var o = e.getTarget();
		if(!working){
			o.menuItem.setSelected(false);
		}
		e.setBubble(false);
	}
	this.transLyr.addEventListener(listener);
	DynAPI.document.addChild(this.imgLyr);
	DynAPI.document.addChild(this.txtLyr);
	DynAPI.document.addChild(this.transLyr);
}
//public
FlatMenuItem.prototype.setSelected = function(selected){
	if(selected || this.permanent){
		this.imgLyr.setImage(this.imgAry[1]);
		this.txtLyr.setHTML("<span class=\""+this.styleClassSelected+"\">"+this.text+"</span>");
	}else{
		this.imgLyr.setImage(this.imgAry[0]);
		this.txtLyr.setHTML("<span class=\""+this.styleClassNormal+"\">"+this.text+"</span>");
	}
}
//public
FlatMenuItem.prototype.moveTo = function(x, y){
	this.imgLyr.moveTo(x,y);
	this.txtLyr.moveTo(x,y);
	this.transLyr.moveTo(x,y);
}
//public
FlatMenuItem.prototype.setVisible = function(visible){
	this.imgLyr.setVisible(visible);
	this.txtLyr.setVisible(visible);
	this.transLyr.setVisible(visible);

}
//public
FlatMenuItem.prototype.showUrl = function(){
	window.location.href = this.url;
}
//public
FlatMenuItem.prototype.setPermanent = function(permanent){
	this.permanent = permanent;
}
working = false;
